/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2024  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region;

import org.bukkit.Location;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Stream;

public class FixedRegionSystem implements RegionSystem {

    private static final Map<String, Region> REGION_MAP = new HashMap<>();

    @Override
    public void load() {
        // TODO: Implement
    }

    @Override
    public void save() {
        // TODO: Implement
    }

    @Override
    public Region getGlobalRegion() {
        return FixedGlobalRegion.INSTANCE;
    }

    @Override
    public Region get(Location location) {
        return REGION_MAP.values().stream()
                .filter(region -> region.inRegion(location))
                .findFirst()
                .orElse(FixedGlobalRegion.INSTANCE);
    }

    @Override
    public Optional<Region> getRegion(String name) {
        return Optional.ofNullable(REGION_MAP.get(name));
    }

    @Override
    public Stream<Region> getRegions() {
        return REGION_MAP.values().stream();
    }

    @Override
    public boolean isModular() {
        return false;
    }
}
